package ${basePackage}.action.ajax.system;

import com.fasterxml.jackson.core.TreeNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.multipart.MultipartFile;
import ${basePackage}.frame.auth.LocalData;
import ${basePackage}.frame.base.BaseResponse;
import ${basePackage}.frame.base.ErrorType;
import ${basePackage}.frame.excel.WSheet;
import ${basePackage}.frame.excel.exception.ReadErrorException;
import ${basePackage}.frame.excel.exception.TemplateNotMatchException;
import ${basePackage}.frame.utils.MapperUtil;
import ${basePackage}.frame.utils.ResponseUtil;
import ${basePackage}.module.system.ent.Dict;
import ${basePackage}.module.system.mgr.DictManager;
import ${basePackage}.module.system.req.*;
import ${basePackage}.module.system.rsp.*;

import java.io.IOException;

public class DictAjax {

    @Autowired
    private DictManager dictManager;

    public DictCreateResponse create(TreeNode jsonParam) {
        DictCreateRequest request = MapperUtil.toJava(jsonParam, DictCreateRequest.class);
        return dictManager.create(request, LocalData.getToken());
    }

    public DictDeleteResponse delete(TreeNode jsonParam) {
        DictDeleteRequest request = MapperUtil.toJava(jsonParam, DictDeleteRequest.class);
        return dictManager.delete(request, LocalData.getToken());
    }

    public DictUpdateResponse update(TreeNode jsonParam) {
        DictUpdateRequest request = MapperUtil.toJava(jsonParam, DictUpdateRequest.class);
        return dictManager.update(request, LocalData.getToken());
    }

    public DictFindResponse find(TreeNode jsonParam) {
        DictFindRequest request = MapperUtil.toJava(jsonParam, DictFindRequest.class);
        return dictManager.find(request, LocalData.getToken());
    }

    public DictGetResponse get(TreeNode jsonParam) {
        DictGetRequest request = MapperUtil.toJava(jsonParam, DictGetRequest.class);
        return dictManager.get(request, LocalData.getToken());
    }

    public DictLoadResponse load(TreeNode jsonParam) {
        DictLoadRequest request = MapperUtil.toJava(jsonParam, DictLoadRequest.class);
        return dictManager.load(request, LocalData.getToken());
    }

    public Object template(){
        return ResponseUtil.apply(new WSheet<>(Dict.class));
    }

    public Object exports(TreeNode jsonParam) {
        DictFindRequest request = MapperUtil.toJava(jsonParam, DictFindRequest.class);
        DictFindResponse response = dictManager.find(request, LocalData.getToken());
        if (response.hasError()) {
            return response;
        }
        return ResponseUtil.apply(new WSheet<>(response.getResult()));
    }

    public Object imports(MultipartFile file) {
        BaseResponse baseResponse = new BaseResponse();
        try {
            WSheet<Dict> sheet = new WSheet<>(file.getBytes(), Dict.class);

            if (sheet.hasError()) {
                return ResponseUtil.apply(sheet.getBytes(), sheet.getName() + "-err.xlsx");
            } else {
                return baseResponse;
            }
        } catch (IOException e) {
            baseResponse.addError(ErrorType.BUSINESS_ERROR, "上传文件出错");
        } catch (TemplateNotMatchException | ReadErrorException e) {
            baseResponse.addError(ErrorType.BUSINESS_ERROR, e.getMessage());
        }
        return baseResponse;
    }
}
